PUBLIC autobaud

baud SEGMENT CODE
RSEG baud

RX      BIT     P3.0
CharH   DATA    30h
CharL   DATA    31h
BaudRate DATA   32h



  Autobaud:
                MOV     TMOD,#01h
                MOV     TH0,#0
                MOV     TL0,#0
                MOV     TCON,#0

                MOV     CharH,#0
                MOV     CharL,#0

  AB0:
                JB      RX,AB0
                SETB    TR0

  AB1:
                JB      TF0,AB3
                JNB     RX,AB1
                MOV     CharH,TH0
                MOV     CharL,TL0

  AB2:
                JB      TF0,AB3
                JB      RX,AB2
                SJMP    AB1

  AB3:
                CLR     TR0
                CLR     TF0

                MOV     BaudRate,#19

  CmpLoop:
                MOV     A,BaudRate
                MOV     DPTR,#CmpTable
                MOVC    A,@A+DPTR
                DEC     BaudRate
                CJNE    A,CharH,Cmp1
                SJMP    CmpLow

  Cmp1:
                JC      CmpMatch
                DJNZ    BaudRate,CmpLoop
                SJMP    CmpMatch

  CmpLow:
                MOV     A,BaudRate
                MOVC    A,@A+DPTR
                CJNE    A,CharL,Cmp2
                SETB    C
  Cmp2:
                JC      CmpMatch
                DJNZ    BaudRate,CmpLoop


  CmpMatch:
                MOV     A,BaudRate
                CLR     C
                RRC     A
                MOV     R7,A
                RET


CmpTable:       DB 40h,0 ; 
                DB 78h,0 ; 
                DB 0f0h,0 ;
                DB 0e0h,01h ; 
                DB 0c0h,03h ; 
                DB 80h,07h ; 
                DB 0,0fh ; 
                DB 0,1eh ; 
                DB 0,3ch ; 
                DB 0,80h ; 
                

END

