#include <reg51.h>                             /* define 8051 registers */
#include <math.h>
#include <intrins.h>
#include <stdio.h>
#define PIa 6.283185307
#define PIb 12.56637061
extern  unsigned char autobaud();

float calcula(float,float);
float ecua(float ecu,float ratio);
int t_carga(float);

unsigned int tabla[]={0,0x10,0xff,0xfd,0xfa,0xf4,0xe8,0xd0,0xa0,0};

void inicia_puerto()
{
  //unsigned char ba=autobaud();
  SCON = 0x52;    /* SCON */                   
  TMOD = 0x20;    /* TMOD */                   
  TCON = 0x69;    /* TCON */
  TH1 =  0xf4;    /* TH1 */
  // TH1=tabla[ba];
}

float calcula(float ratio,float toleran)
{
    float ant,actual;
    unsigned int i=0;
    ratio=ratio/100;
    actual=0;
        do
        {
                
                ant=actual;
                actual=ecua(ant,ratio);
                printf("raiz[%d]=%f \n",i++,actual); 
        }
       while((fabs(actual-ant)>toleran) || (fabs(1-2.0*actual+(sin(PIb*actual))/PIa-ratio)>toleran));

    return actual;
}



float ecua(float ecu,float ratio)
{
  
   return(0.5-ratio*0.5+(sin(PIb*ecu))/(PIb));

}

int t_carga(float p)
{       
        return(65536-(p*20*1000*11.0592/12));
                  
}

